# Waterfall run events (/docs/api/waterfalls/waterfall_run_events)

Progress events of a run after a sequence number (the SSE stream's JSON form).

`GET /v1/waterfalls/{id}/runs/{run_id}/events.json`

```json
{
  "operationId": "waterfall_run_events",
  "summary": "Waterfall run events",
  "description": "Progress events of a run after a sequence number (the SSE stream's JSON form).",
  "tags": [
    "waterfalls"
  ],
  "security": [
    {
      "bearer": []
    }
  ],
  "parameters": [
    {
      "schema": {
        "type": "string",
        "pattern": "^wf_[a-z0-9]{8,40}$"
      },
      "required": true,
      "name": "id",
      "in": "path"
    },
    {
      "schema": {
        "type": "string",
        "pattern": "^wfr_[a-z0-9]{8,64}$"
      },
      "required": true,
      "name": "run_id",
      "in": "path"
    },
    {
      "schema": {
        "type": [
          "integer",
          "null"
        ],
        "minimum": 0,
        "default": 0
      },
      "required": false,
      "name": "after",
      "in": "query"
    }
  ],
  "responses": {
    "200": {
      "description": "OK",
      "content": {
        "application/json": {
          "schema": {
            "type": "object",
            "properties": {
              "items": {
                "type": "array",
                "items": {
                  "type": "object",
                  "properties": {
                    "seq": {
                      "type": "integer",
                      "minimum": 0
                    },
                    "type": {
                      "type": "string",
                      "enum": [
                        "run.started",
                        "attempt.started",
                        "attempt.finished",
                        "stage.finished",
                        "run.finished"
                      ]
                    },
                    "at_ms": {
                      "type": "integer",
                      "minimum": 0
                    },
                    "data": {
                      "type": "object",
                      "additionalProperties": {}
                    }
                  },
                  "required": [
                    "seq",
                    "type",
                    "at_ms",
                    "data"
                  ]
                }
              }
            },
            "required": [
              "items"
            ]
          }
        }
      }
    },
    "default": {
      "description": "Error",
      "content": {
        "application/json": {
          "schema": {
            "type": "object",
            "properties": {
              "error": {
                "type": "object",
                "properties": {
                  "code": {
                    "type": "string",
                    "enum": [
                      "invalid_request",
                      "unauthorized",
                      "insufficient_balance",
                      "max_cost_exceeded",
                      "scope_denied",
                      "budget_blocked",
                      "not_found",
                      "idempotency_mismatch",
                      "invalid_meta",
                      "rate_limited",
                      "upstream_error",
                      "response_buffer_limit",
                      "provider_capacity_unavailable",
                      "grid_saturated",
                      "upstream_timeout",
                      "conflict",
                      "internal_error",
                      "account_frozen",
                      "strict_filters",
                      "plan_limit_reached",
                      "validation_failed",
                      "deadline_exceeded",
                      "cancelled"
                    ]
                  },
                  "message": {
                    "type": "string"
                  },
                  "request_id": {
                    "type": "string"
                  },
                  "call_id": {
                    "type": "string"
                  },
                  "retry_after_ms": {
                    "type": "integer",
                    "minimum": 0
                  },
                  "details": {
                    "type": "object",
                    "additionalProperties": {}
                  }
                },
                "required": [
                  "code",
                  "message"
                ]
              }
            },
            "required": [
              "error"
            ]
          }
        }
      }
    }
  }
}
```
